<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>folder_structure.schema &#8212; folder-structure 0.0.post1.dev1+g08229bb.d20231212 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=9da889c1"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for folder_structure.schema</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">annotations</span>

<span class="kn">import</span> <span class="nn">json</span>
<span class="kn">from</span> <span class="nn">.folder</span> <span class="kn">import</span> <span class="n">Folder</span>
<span class="kn">from</span> <span class="nn">pprint</span> <span class="kn">import</span> <span class="n">pformat</span>

<div class="viewcode-block" id="Schema">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.schema.Schema">[docs]</a>
<span class="k">class</span> <span class="nc">Schema</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This class is used to process an appropriately formatted schema document</span>
<span class="sd">    (JSON) that defines the contents (relationships) that exist in a project.</span>


<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">knownClasses</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
    
    <span class="k">def</span> <span class="fm">__getitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">knownClasses</span><span class="p">[</span><span class="n">key</span><span class="p">]</span>
    
<div class="viewcode-block" id="Schema.is_folder">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.schema.Schema.is_folder">[docs]</a>
    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">is_folder</span><span class="p">(</span><span class="n">key_class_instance</span><span class="p">):</span>
        <span class="n">obj</span> <span class="o">=</span> <span class="n">Schema</span><span class="o">.</span><span class="n">knownClasses</span><span class="p">[</span><span class="n">key_class_instance</span><span class="p">]</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">key_class_instance</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span> <span class="k">else</span> <span class="n">key_class_instance</span>
        <span class="k">return</span> <span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">obj</span><span class="p">,</span> <span class="n">Folder</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">issubclass</span><span class="p">(</span><span class="n">obj</span><span class="p">,</span> <span class="n">Folder</span><span class="p">))</span></div>

    
<div class="viewcode-block" id="Schema.generate">
<a class="viewcode-back" href="../../api/folder_structure.html#folder_structure.schema.Schema.generate">[docs]</a>
    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">generate</span><span class="p">(</span><span class="n">schema</span><span class="p">,</span> <span class="n">reset</span><span class="p">:</span> <span class="nb">bool</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Generate the elements defined in a JSON-formatted schema where each</span>
<span class="sd">        entry has the following structure:</span>
<span class="sd">        </span>
<span class="sd">            {</span>
<span class="sd">                &quot;type&quot;: (class name, str),</span>
<span class="sd">                &quot;base&quot;: (name of the base class, str, or Folder),</span>
<span class="sd">                &quot;contains&quot;: (contents of the folder, dict[str, str])</span>
<span class="sd">            }</span>

<span class="sd">        The &quot;contains&quot; field defines the entries by name. This, then, requires</span>
<span class="sd">        all subfolder names to be unique within a folder.</span>

<span class="sd">            &quot;contains&quot;: {</span>
<span class="sd">                name1: type1,</span>
<span class="sd">                name2: type2,</span>
<span class="sd">                ...</span>
<span class="sd">            }</span>
<span class="sd">        </span>
<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        schema : str or list</span>
<span class="sd">            Filename containing the JSON schema or a JSON-formatted object.</span>
<span class="sd">        </span>
<span class="sd">        reset : bool</span>
<span class="sd">            Whether to reset the existing schema. Default is True, that is, each</span>
<span class="sd">            call will generate a new Schema. If False, then the classes created</span>
<span class="sd">            will build upon one another from one file to the next.</span>
<span class="sd">            </span>
<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        instance : Schema</span>
<span class="sd">            Instance of the Schema type.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">reset</span> <span class="ow">or</span> <span class="nb">len</span><span class="p">(</span><span class="n">Schema</span><span class="o">.</span><span class="n">knownClasses</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">Schema</span><span class="o">.</span><span class="n">knownClasses</span> <span class="o">=</span> <span class="p">{</span>
                <span class="s2">&quot;Folder&quot;</span><span class="p">:</span> <span class="n">Folder</span>
            <span class="p">}</span>
        <span class="c1"># Open the JSON file that contains the schema</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">schema</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">schema</span><span class="p">)</span> <span class="k">as</span> <span class="n">ifs</span><span class="p">:</span>
                <span class="n">queue</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">ifs</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">queue</span> <span class="o">=</span> <span class="n">schema</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">queue</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;The schema must be a list of JSON-formatted types.&quot;</span><span class="p">)</span>
        <span class="c1"># Counter to check for a missing definition</span>
        <span class="c1"># This allows folder types to be specified in any order.</span>
        <span class="n">maxlength</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">queue</span><span class="p">)</span>
        <span class="n">missing</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
        <span class="k">while</span> <span class="kc">True</span><span class="p">:</span>
            <span class="c1"># get the first entry</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">entry</span> <span class="o">=</span> <span class="n">queue</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
                <span class="c1"># all entries have been processed</span>
                <span class="k">break</span>
            <span class="c1"># get the key/value pairs from the schema</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">classname</span> <span class="o">=</span> <span class="n">entry</span><span class="p">[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span>
                <span class="n">basename</span> <span class="o">=</span> <span class="n">entry</span><span class="p">[</span><span class="s2">&quot;base&quot;</span><span class="p">]</span>
                <span class="n">contents</span> <span class="o">=</span> <span class="n">entry</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;contains&quot;</span><span class="p">,</span> <span class="nb">dict</span><span class="p">())</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">contents</span><span class="p">,</span> <span class="nb">dict</span><span class="p">):</span>
                    <span class="k">raise</span> <span class="ne">KeyError</span><span class="p">()</span>
            <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s2">&quot;Entry </span><span class="si">{}</span><span class="s2"> does not have the proper &quot;</span>
                              <span class="s2">&quot;format.&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">pformat</span><span class="p">(</span><span class="n">entry</span><span class="p">)))</span>
            <span class="k">if</span> <span class="n">classname</span> <span class="ow">in</span> <span class="n">Schema</span><span class="o">.</span><span class="n">knownClasses</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">KeyError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">classname</span><span class="si">!r}</span><span class="s2"> is defined multiple times.&quot;</span><span class="p">)</span>
            <span class="c1"># create the class</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">base</span> <span class="o">=</span> <span class="n">Schema</span><span class="p">()[</span><span class="n">basename</span><span class="p">]</span>

                <span class="k">if</span> <span class="n">Schema</span><span class="o">.</span><span class="n">is_folder</span><span class="p">(</span><span class="n">base</span><span class="p">):</span>
                    <span class="n">methods</span> <span class="o">=</span> <span class="p">{</span>
                        <span class="s1">&#39;__new__&#39;</span><span class="p">:</span> <span class="n">Schema</span><span class="o">.</span><span class="n">_folder_new_factory</span><span class="p">(</span><span class="n">base</span><span class="p">),</span>
                        <span class="s1">&#39;__init__&#39;</span><span class="p">:</span> <span class="n">Schema</span><span class="o">.</span><span class="n">_folder_init_factory</span><span class="p">(</span><span class="n">contents</span><span class="p">,</span> <span class="n">base</span><span class="p">),</span>
                        <span class="s1">&#39;build&#39;</span><span class="p">:</span> <span class="n">Schema</span><span class="o">.</span><span class="n">_folder_build_factory</span><span class="p">()</span>
                    <span class="p">}</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">{}</span><span class="s2"> is not a recognized type.&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">base</span><span class="p">))</span>
                
                <span class="n">Schema</span><span class="o">.</span><span class="n">knownClasses</span><span class="p">[</span><span class="n">classname</span><span class="p">]</span> <span class="o">=</span> <span class="nb">type</span><span class="p">(</span>
                    <span class="n">classname</span><span class="p">,</span>
                    <span class="p">(</span><span class="n">base</span><span class="p">,),</span>
                    <span class="n">methods</span>
                <span class="p">)</span>
                
                <span class="c1"># successfully generated a class</span>
                <span class="c1"># reset the counter that checks for missing definitions</span>
                <span class="n">maxlength</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">queue</span><span class="p">)</span>
                <span class="n">missing</span> <span class="o">=</span> <span class="n">missing</span> <span class="o">-</span> <span class="p">{</span><span class="n">classname</span><span class="p">}</span>
            <span class="k">except</span> <span class="p">(</span><span class="ne">KeyError</span><span class="p">,</span> <span class="ne">TypeError</span><span class="p">):</span>
                <span class="c1"># A key error means we haven&#39;t reached the definition</span>
                <span class="c1"># of an entry yet. maxlength is the maximum length of the</span>
                <span class="c1"># queue before realizing that a class has not been</span>
                <span class="c1"># defined.</span>
                <span class="n">queue</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">entry</span><span class="p">)</span>
                <span class="n">maxlength</span> <span class="o">=</span> <span class="n">maxlength</span> <span class="o">-</span> <span class="mi">1</span>
                <span class="n">missing</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">classname</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">maxlength</span> <span class="o">&lt;</span> <span class="mi">1</span><span class="p">:</span>
                    <span class="c1"># we&#39;ve gone through every entry in the schema at least once</span>
                    <span class="c1"># without defining a type that was used.</span>
                    <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s2">&quot;The following objects have not been defined &quot;</span>
                                  <span class="s2">&quot;in the schema: </span><span class="si">{}</span><span class="s2">.&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">missing</span><span class="p">)))</span>
        <span class="k">return</span> <span class="n">Schema</span><span class="p">()</span></div>

    
    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">_folder_new_factory</span><span class="p">(</span><span class="n">base</span><span class="p">):</span>
        <span class="k">def</span> <span class="nf">new</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">):</span>
            <span class="c1"># Check for self-reference</span>
            <span class="k">if</span> <span class="bp">cls</span> <span class="ow">in</span> <span class="bp">cls</span><span class="o">.</span><span class="n">mro</span><span class="p">()[</span><span class="mi">1</span><span class="p">:]:</span>
                <span class="c1"># Class MRO, including the current, are listed with this class first.</span>
                <span class="c1"># Because classes are created and resolved dynamically, it is possible</span>
                <span class="c1"># for a class to refer to itself.</span>
                <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Definition of </span><span class="si">{</span><span class="bp">cls</span><span class="si">!r}</span><span class="s2"> contains a self-reference.&quot;</span><span class="p">)</span>
            <span class="k">return</span> <span class="n">base</span><span class="o">.</span><span class="fm">__new__</span><span class="p">(</span><span class="bp">cls</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">new</span>
    
    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">_folder_init_factory</span><span class="p">(</span><span class="n">contents</span><span class="p">,</span> <span class="n">base</span><span class="p">):</span>
        <span class="k">def</span> <span class="nf">init</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">parent</span><span class="p">:</span> <span class="n">Folder</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
            <span class="c1"># Check for self-reference</span>
            <span class="k">if</span> <span class="nb">type</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">type</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="n">mro</span><span class="p">()[</span><span class="mi">1</span><span class="p">:]:</span>
                <span class="c1"># Class MRO, including the current, are listed with this class first.</span>
                <span class="c1"># Because classes are created and resolved dynamically, it is possible</span>
                <span class="c1"># for a class to refer to itself.</span>
                <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Definition of </span><span class="si">{</span><span class="nb">type</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span><span class="si">!r}</span><span class="s2"> contains a self-reference.&quot;</span><span class="p">)</span>
            <span class="n">base</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">parent</span><span class="o">=</span><span class="n">parent</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">contents</span> <span class="o">=</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;contents&quot;</span><span class="p">,</span> <span class="nb">list</span><span class="p">())</span> <span class="c1"># contents from base class</span>
            <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">typename</span> <span class="ow">in</span> <span class="n">contents</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="bp">cls</span> <span class="o">=</span> <span class="n">Schema</span><span class="p">()[</span><span class="n">typename</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">contents</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">cls</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">parent</span><span class="o">=</span><span class="bp">self</span><span class="p">))</span>
                <span class="c1"># self.contents.append(cls(name=name, parent=parent))</span>
        <span class="k">return</span> <span class="n">init</span>
    
    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">_folder_build_factory</span><span class="p">():</span>
        <span class="k">def</span> <span class="nf">build</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="mo">0o777</span><span class="p">,</span> <span class="n">parents</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">root</span><span class="p">:</span> <span class="nb">str</span><span class="o">=</span><span class="s2">&quot;.&quot;</span><span class="p">):</span>
            <span class="n">Folder</span><span class="o">.</span><span class="n">build</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="n">mode</span><span class="p">,</span> <span class="n">parents</span><span class="o">=</span><span class="n">parents</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="n">exist_ok</span><span class="p">,</span> <span class="n">root</span><span class="o">=</span><span class="n">root</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">contents</span><span class="p">:</span>
                <span class="n">child</span><span class="o">.</span><span class="n">build</span><span class="p">(</span><span class="n">mode</span><span class="o">=</span><span class="n">mode</span><span class="p">,</span> <span class="n">parents</span><span class="o">=</span><span class="n">parents</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">root</span><span class="o">=</span><span class="n">root</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">build</span></div>

    
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">folder-structure</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../api/modules.html">Module Reference</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Branden Kappes.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>